<template>
  <div>
    <v-toolbar app>
      <v-toolbar-title>{{`Código para ${$route.params.location}`}}</v-toolbar-title>
      <v-spacer></v-spacer>

      <v-btn icon @click="$store.dispatch('sync')">
        <v-icon>save</v-icon>
      </v-btn>
    </v-toolbar>
    <v-content>
      <div class="pa-3">
        <v-switch label="Modo contínuo" v-model="continuous" />
        <qrcode-stream @decode="onDecode" />
        <v-layout align-center justify-center row fill-height>
          <v-text-field mask="####-#" v-model="qrcode" placeholder="QR code" />
          <v-btn @click="save">Salvar</v-btn>
        </v-layout>
        <v-alert type="success" :value="alert.success">{{`Código ${this.qrcode} lido com sucesso`}}</v-alert>
        <v-alert type="error" :value="alert.error">Código Inválido</v-alert>
      </div>
      <v-list two-line>
        <v-list-tile v-for="cp in checkpoints" :key="cp.data.id">
          <v-list-tile-title>
            <v-icon>{{cp.metadata.uploaded ? 'check': 'close'}}</v-icon>
            {{cp.data.code}}
          </v-list-tile-title>
          <v-list-tile-sub-title>{{cp.data.timestamp}}</v-list-tile-sub-title>
        </v-list-tile>
      </v-list>
    </v-content>
  </div>
</template>

<script>
import { QrcodeStream } from "vue-qrcode-reader";
import { mapGetters } from "vuex";

export default {
  components: {
    QrcodeStream
  },
  data() {
    return {
      qrcode: "",
      continuous: false,
      alert: {
        success: false,
        error: false
      }
    };
  },
  computed: {
    ...mapGetters(["checkpoints"])
  },
  methods: {
    onDecode(decodedString) {
      if (this.verifyCode(decodedString)) {
        this.alert.success = true;
        this.qrcode = decodedString;
        window.setTimeout(() => (this.alert.success = false), 700);
        if (this.continuous) this.save();
      } else {
        this.alert.error = true;
        window.setTimeout(() => (this.alert.error = false), 700);
      }
    },
    verifyCode(code) {
      const digits = code
        .slice(0, code.length - 1)
        .split("")
        .map(dig => parseInt(dig));
      const vdigit = parseInt(code.slice(code.length - 1));

      const expected =
        digits
          .map((dig, index) => Math.pow((index + 1) * dig, 3))
          .reduce((a, b) => a + b) % 10;

      return vdigit === expected;
    },
    async save() {
      try {
        await this.$store.commit("addCheckpoint", {
          place: this.$route.params.location,
          code: this.qrcode
        });
        this.qrcode = "";
      } catch (e) {
        console.error(e);
      }
    }
  }
};
</script>
